Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/app/processors/TextProcessor", ['module', 'exports', 'require', './getAlloyEditorProcessor', './getLinkableEditableEditorWrapper'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _getAlloyEditorProcessor = _interopRequireDefault(require("./getAlloyEditorProcessor"));

    var _getLinkableEditableEditorWrapper = require("./getLinkableEditableEditorWrapper");

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var _default = (0, _getAlloyEditorProcessor.default)('text', _getLinkableEditableEditorWrapper.getLinkableEditableEditorWrapper, function (element, value) {
      var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (config.href) {
        var anchor = element instanceof HTMLAnchorElement ? element : element.querySelector('a');

        if (!anchor) {
          anchor = document.createElement('a');
        }

        anchor.href = config.href;
        anchor.target = config.target || '';
        anchor.innerHTML = value;

        if (!element.contains(anchor)) {
          element.innerHTML = anchor.outerHTML;
        }
      } else if (value) {
        element.innerHTML = value;
      }
    });

    exports.default = _default;
    //# sourceMappingURL=TextProcessor.js.map
  }
});
//# sourceMappingURL=TextProcessor.js.map