Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/app/utils/updateIn", ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.updateIn = void 0;

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance");
    }

    function _iterableToArray(iter) {
      if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) {
        for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
          arr2[i] = arr[i];
        }return arr2;
      }
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var updateIn = function updateIn(objectOrArray, keyPathOrKey, updater) {
      var defaultValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
      var keyPath = typeof keyPathOrKey === 'string' ? [keyPathOrKey] : keyPathOrKey;

      var _keyPath = _slicedToArray(keyPath, 1),
          nextKey = _keyPath[0];

      var nextObjectOrArray = objectOrArray;

      if (keyPath.length > 1) {
        nextObjectOrArray = Array.isArray(nextObjectOrArray) ? _toConsumableArray(nextObjectOrArray) : _objectSpread({}, nextObjectOrArray);
        nextObjectOrArray[nextKey] = updateIn(nextObjectOrArray[nextKey] || {}, keyPath.slice(1), updater, defaultValue);
      } else {
        var nextValue = typeof nextObjectOrArray[nextKey] === 'undefined' ? defaultValue : nextObjectOrArray[nextKey];
        var updatedNextValue = updater(nextValue);

        if (updatedNextValue !== nextObjectOrArray[nextKey]) {
          nextObjectOrArray = Array.isArray(nextObjectOrArray) ? _toConsumableArray(nextObjectOrArray) : _objectSpread({}, nextObjectOrArray);
          nextObjectOrArray[nextKey] = updatedNextValue;
        }
      }

      return nextObjectOrArray;
    };

    exports.updateIn = updateIn;
    //# sourceMappingURL=updateIn.js.map
  }
});
//# sourceMappingURL=updateIn.js.map