Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/common/components/ItemSelector", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', '@frontend-taglib-clay$clayui/form', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../../app/config/index', '../../app/store/index', '../../app/utils/useId', '../../core/openInfoItemSelector'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = ItemSelector;

    var _button = require("@frontend-taglib-clay$clayui/button");

    var _dropDown = _interopRequireDefault(require("@frontend-taglib-clay$clayui/drop-down"));

    var _form = require("@frontend-taglib-clay$clayui/form");

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _index = require("../../app/config/index");

    var _index2 = require("../../app/store/index");

    var _useId = require("../../app/utils/useId");

    var _openInfoItemSelector = require("../../core/openInfoItemSelector");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function ItemSelector(_ref) {
      var eventName = _ref.eventName,
          itemSelectorURL = _ref.itemSelectorURL,
          label = _ref.label,
          onItemSelect = _ref.onItemSelect,
          _ref$quickMappedInfoI = _ref.quickMappedInfoItems,
          quickMappedInfoItems = _ref$quickMappedInfoI === void 0 ? [] : _ref$quickMappedInfoI,
          selectedItemTitle = _ref.selectedItemTitle,
          _ref$showAddButton = _ref.showAddButton,
          showAddButton = _ref$showAddButton === void 0 ? true : _ref$showAddButton,
          _ref$showMappedItems = _ref.showMappedItems,
          showMappedItems = _ref$showMappedItems === void 0 ? true : _ref$showMappedItems;

      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          active = _useState2[0],
          setActive = _useState2[1];

      var itemSelectorInputId = (0, _useId.useId)();
      var mappedInfoItems = (0, _index2.useSelector)(function (state) {
        return state.mappedInfoItems || [];
      });
      var mappedItems = quickMappedInfoItems.length === 0 ? mappedInfoItems : quickMappedInfoItems;
      var defaultEventName = "".concat(_index.config.portletNamespace, "selectInfoItem");
      return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, label && /*#__PURE__*/_react.default.createElement("label", {
          htmlFor: itemSelectorInputId
        }, label), /*#__PURE__*/_react.default.createElement("div", {
          className: "d-flex"
        }, /*#__PURE__*/_react.default.createElement(_form.ClayInput, {
          className: (0, _classnames.default)('mr-2', {
            'page-editor__item-selector__content-input': showAddButton
          }),
          id: itemSelectorInputId,
          onClick: function onClick() {
            if (showAddButton) {
              (0, _openInfoItemSelector.openInfoItemSelector)(onItemSelect, eventName || defaultEventName, itemSelectorURL || _index.config.infoItemSelectorURL);
            }
          },
          readOnly: true,
          sizing: "sm",
          type: "text",
          value: selectedItemTitle || ''
        }), showAddButton && (mappedItems.length > 0 && showMappedItems ? /*#__PURE__*/_react.default.createElement(_dropDown.default, {
          active: active,
          onActiveChange: setActive,
          trigger: /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
            "aria-label": Liferay.Language.get('select-content-button'),
            className: 'page-editor__item-selector__content-button',
            displayType: "secondary",
            onClick: function onClick() {
              return setActive(true);
            },
            small: true,
            symbol: "plus"
          })
        }, /*#__PURE__*/_react.default.createElement(_dropDown.default.ItemList, null, mappedItems.map(function (item) {
          return (/*#__PURE__*/_react.default.createElement(_dropDown.default.Item, {
              key: item.classNameId,
              onClick: function onClick() {
                onItemSelect(item);
                setActive(false);
              }
            }, item.title)
          );
        }), /*#__PURE__*/_react.default.createElement(_dropDown.default.Divider, null), /*#__PURE__*/_react.default.createElement(_dropDown.default.Item, {
          onClick: function onClick() {
            (0, _openInfoItemSelector.openInfoItemSelector)(onItemSelect, eventName || defaultEventName, itemSelectorURL || _index.config.infoItemSelectorURL);
            setActive(false);
          }
        }, Liferay.Language.get('select-content'), "..."))) : /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
          "aria-label": Liferay.Language.get('select-content-button'),
          className: 'page-editor__item-selector__content-button',
          displayType: "secondary",
          onClick: function onClick() {
            return (0, _openInfoItemSelector.openInfoItemSelector)(onItemSelect, eventName || defaultEventName, itemSelectorURL || _index.config.infoItemSelectorURL);
          },
          small: true,
          symbol: "plus"
        }))))
      );
    }
    //# sourceMappingURL=ItemSelector.js.map
  }
});
//# sourceMappingURL=ItemSelector.js.map