Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/app/components/fragment-content/EditableProcessorContext", ['module', 'exports', 'require', 'frontend-js-react-web$react', '../CollectionItemContext'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.EditableProcessorContextProvider = EditableProcessorContextProvider;
    exports.useEditableProcessorClickPosition = useEditableProcessorClickPosition;
    exports.useEditableProcessorUniqueId = useEditableProcessorUniqueId;
    exports.useIsProcessorEnabled = useIsProcessorEnabled;
    exports.useSetEditableProcessorUniqueId = useSetEditableProcessorUniqueId;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _CollectionItemContext = require("../CollectionItemContext");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var INITIAL_STATE = {
      editableClickPosition: null,
      editableUniqueId: null
    };

    var EditableProcessorDispatchContext = /*#__PURE__*/_react.default.createContext(function () {});

    var EditableProcessorRefContext = /*#__PURE__*/_react.default.createContext({
      current: null
    });

    var EditableProcessorStateContext = /*#__PURE__*/_react.default.createContext(INITIAL_STATE);

    function EditableProcessorContextProvider(_ref) {
      var children = _ref.children;

      var _useState = (0, _react.useState)(INITIAL_STATE),
          _useState2 = _slicedToArray(_useState, 2),
          state = _useState2[0],
          setState = _useState2[1];

      var ref = (0, _react.useRef)(null);
      ref.current = state;
      return (/*#__PURE__*/_react.default.createElement(EditableProcessorDispatchContext.Provider, {
          value: setState
        }, /*#__PURE__*/_react.default.createElement(EditableProcessorRefContext.Provider, {
          value: ref
        }, /*#__PURE__*/_react.default.createElement(EditableProcessorStateContext.Provider, {
          value: state
        }, children)))
      );
    }

    function useEditableProcessorClickPosition() {
      var state = (0, _react.useContext)(EditableProcessorStateContext);
      return state.editableClickPosition;
    }

    function useEditableProcessorUniqueId() {
      return (0, _react.useContext)(EditableProcessorStateContext).editableUniqueId;
    }

    function useIsProcessorEnabled() {
      var ref = (0, _react.useContext)(EditableProcessorRefContext);
      var toControlsId = (0, _CollectionItemContext.useToControlsId)();
      return (0, _react.useCallback)(function () {
        var _ref$current, _ref$current2;

        var editableUniqueId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        return editableUniqueId ? ((_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.editableUniqueId) === toControlsId(editableUniqueId) : !!((_ref$current2 = ref.current) === null || _ref$current2 === void 0 ? void 0 : _ref$current2.editableUniqueId);
      }, [ref, toControlsId]);
    }

    function useSetEditableProcessorUniqueId() {
      var setState = (0, _react.useContext)(EditableProcessorDispatchContext);
      var toControlsId = (0, _CollectionItemContext.useToControlsId)();
      return (0, _react.useCallback)(function (editableUniqueIdOrNull) {
        var editableClickPosition = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        setState({
          editableClickPosition: editableClickPosition,
          editableUniqueId: toControlsId(editableUniqueIdOrNull)
        });
      }, [setState, toControlsId]);
    }
    //# sourceMappingURL=EditableProcessorContext.js.map
  }
});
//# sourceMappingURL=EditableProcessorContext.js.map