Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/app/selectors/selectEditableValueContent", ['module', 'exports', 'require', '../config/index', './selectEditableValue'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = selectEditableValueContent;

    var _index = require("../config/index");

    var _selectEditableValue = _interopRequireDefault(require("./selectEditableValue"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function selectEditableValueContent(state, fragmentEntryLinkId, editableId, processorType) {
      var languageId = state.languageId;
      var data = (0, _selectEditableValue.default)(state, fragmentEntryLinkId, editableId, processorType);
      var content = data;

      if (content[languageId]) {
        content = content[languageId];
      } else if (content[_index.config.defaultLanguageId]) {
        content = content[_index.config.defaultLanguageId];
      }

      if (content == null || content.defaultValue) {
        content = data.defaultValue;
      }

      return content;
    }
    //# sourceMappingURL=selectEditableValueContent.js.map
  }
});
//# sourceMappingURL=selectEditableValueContent.js.map