Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/app/thunks/updateItemConfig", ['module', 'exports', 'require', '../actions/updateItemConfig', '../actions/updatePageContents', '../services/InfoItemService', '../services/LayoutService'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = updateItemConfig;

    var _updateItemConfig = _interopRequireDefault(require("../actions/updateItemConfig"));

    var _updatePageContents = _interopRequireDefault(require("../actions/updatePageContents"));

    var _InfoItemService = _interopRequireDefault(require("../services/InfoItemService"));

    var _LayoutService = _interopRequireDefault(require("../services/LayoutService"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function updateItemConfig(_ref) {
      var itemConfig = _ref.itemConfig,
          itemId = _ref.itemId,
          segmentsExperienceId = _ref.segmentsExperienceId;
      return function (dispatch) {
        return _LayoutService.default.updateItemConfig({
          itemConfig: itemConfig,
          itemId: itemId,
          onNetworkStatus: dispatch,
          segmentsExperienceId: segmentsExperienceId
        }).then(function (layoutData) {
          dispatch((0, _updateItemConfig.default)({
            itemId: itemId,
            layoutData: layoutData
          }));
        }).then(function () {
          _InfoItemService.default.getPageContents({
            onNetworkStatus: dispatch
          }).then(function (pageContents) {
            dispatch((0, _updatePageContents.default)({
              pageContents: pageContents
            }));
          });
        });
      };
    }
    //# sourceMappingURL=updateItemConfig.js.map
  }
});
//# sourceMappingURL=updateItemConfig.js.map