Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/plugins/experience/thunks/updateExperiencePriority", ['module', 'exports', 'require', '../../../app/services/ExperienceService', '../actions/updateExperiencesList'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = updateExperiencePriority;

    var _ExperienceService = _interopRequireDefault(require("../../../app/services/ExperienceService"));

    var _updateExperiencesList = _interopRequireDefault(require("../actions/updateExperiencesList"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function updateExperiencePriority(_ref) {
      var priority = _ref.priority,
          segmentsExperienceId = _ref.segmentsExperienceId;
      return function (dispatch) {
        return _ExperienceService.default.updateExperiencePriority({
          body: {
            newPriority: priority,
            segmentsExperienceId: segmentsExperienceId
          },
          dispatch: dispatch
        }).then(function (_ref2) {
          var availableSegmentsExperiences = _ref2.availableSegmentsExperiences;
          return dispatch((0, _updateExperiencesList.default)(availableSegmentsExperiences));
        });
      };
    }
    //# sourceMappingURL=updateExperiencePriority.js.map
  }
});
//# sourceMappingURL=updateExperiencePriority.js.map