Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/plugins/fragments-widgets/components/SearchResultsPanel", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/alert', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './TabCollection'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = SearchResultsPanel;

    var _alert = _interopRequireDefault(require("@frontend-taglib-clay$clayui/alert"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _TabCollection = _interopRequireDefault(require("./TabCollection"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function SearchResultsPanel(_ref) {
      var filteredTabs = _ref.filteredTabs;
      return filteredTabs.length ? filteredTabs.map(function (tab, index) {
        return (/*#__PURE__*/_react.default.createElement("div", {
            key: index
          }, /*#__PURE__*/_react.default.createElement("div", {
            className: "page-editor__fragments-widgets__search-results-panel__filter-subtitle"
          }, tab.label), tab.collections.map(function (collection, index) {
            return (/*#__PURE__*/_react.default.createElement(_TabCollection.default, {
                collection: collection,
                isSearchResult: true,
                key: index,
                open: true
              })
            );
          }))
        );
      }) : /*#__PURE__*/_react.default.createElement(_alert.default, {
        displayType: "info",
        title: Liferay.Language.get('info')
      }, Liferay.Language.get('there-are-no-fragments-or-widgets-on-this-page'));
    }

    SearchResultsPanel.proptypes = {
      filteredTabs: _propTypes.default.object.isRequired
    };
    //# sourceMappingURL=SearchResultsPanel.js.map
  }
});
//# sourceMappingURL=SearchResultsPanel.js.map