Liferay.Loader.define("layout-content-page-editor-web@2.0.162/page_editor/prop-types/getEditableItemPropTypes", ['module', 'exports', 'require', 'frontend-js-react-web$prop-types', '../app/config/constants/editableTypes'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = getEditableItemPropTypes;

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _editableTypes = require("../app/config/constants/editableTypes");

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function getEditableItemPropTypes() {
      var extraPropTypes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return _propTypes.default.shape(_objectSpread({
        editableId: _propTypes.default.string.isRequired,
        fragmentEntryLinkId: _propTypes.default.string.isRequired,
        itemId: _propTypes.default.string.isRequired,
        type: _propTypes.default.oneOf(Object.values(_editableTypes.EDITABLE_TYPES))
      }, extraPropTypes));
    }
    //# sourceMappingURL=getEditableItemPropTypes.js.map
  }
});
//# sourceMappingURL=getEditableItemPropTypes.js.map